//go:build !ignore_autogenerated
// +build !ignore_autogenerated

/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by conversion-gen. DO NOT EDIT.

package v1beta2

import (
	unsafe "unsafe"

	corev1 "k8s.io/api/core/v1"
	resourcev1beta2 "k8s.io/api/resource/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	runtime "k8s.io/apimachinery/pkg/runtime"
	types "k8s.io/apimachinery/pkg/types"
	core "k8s.io/kubernetes/pkg/apis/core"
	resource "k8s.io/kubernetes/pkg/apis/resource"
)

func init() {
	localSchemeBuilder.Register(RegisterConversions)
}

// RegisterConversions adds conversion functions to the given scheme.
// Public to allow building arbitrary schemes.
func RegisterConversions(s *runtime.Scheme) error {
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.AllocatedDeviceStatus)(nil), (*resource.AllocatedDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AllocatedDeviceStatus_To_resource_AllocatedDeviceStatus(a.(*resourcev1beta2.AllocatedDeviceStatus), b.(*resource.AllocatedDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.AllocatedDeviceStatus)(nil), (*resourcev1beta2.AllocatedDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(a.(*resource.AllocatedDeviceStatus), b.(*resourcev1beta2.AllocatedDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.AllocationResult)(nil), (*resource.AllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AllocationResult_To_resource_AllocationResult(a.(*resourcev1beta2.AllocationResult), b.(*resource.AllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.AllocationResult)(nil), (*resourcev1beta2.AllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_AllocationResult_To_v1beta2_AllocationResult(a.(*resource.AllocationResult), b.(*resourcev1beta2.AllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.CELDeviceSelector)(nil), (*resource.CELDeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_CELDeviceSelector_To_resource_CELDeviceSelector(a.(*resourcev1beta2.CELDeviceSelector), b.(*resource.CELDeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.CELDeviceSelector)(nil), (*resourcev1beta2.CELDeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_CELDeviceSelector_To_v1beta2_CELDeviceSelector(a.(*resource.CELDeviceSelector), b.(*resourcev1beta2.CELDeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.Counter)(nil), (*resource.Counter)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_Counter_To_resource_Counter(a.(*resourcev1beta2.Counter), b.(*resource.Counter), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.Counter)(nil), (*resourcev1beta2.Counter)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_Counter_To_v1beta2_Counter(a.(*resource.Counter), b.(*resourcev1beta2.Counter), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.CounterSet)(nil), (*resource.CounterSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_CounterSet_To_resource_CounterSet(a.(*resourcev1beta2.CounterSet), b.(*resource.CounterSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.CounterSet)(nil), (*resourcev1beta2.CounterSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_CounterSet_To_v1beta2_CounterSet(a.(*resource.CounterSet), b.(*resourcev1beta2.CounterSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.Device)(nil), (*resource.Device)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_Device_To_resource_Device(a.(*resourcev1beta2.Device), b.(*resource.Device), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.Device)(nil), (*resourcev1beta2.Device)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_Device_To_v1beta2_Device(a.(*resource.Device), b.(*resourcev1beta2.Device), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceAllocationConfiguration)(nil), (*resource.DeviceAllocationConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAllocationConfiguration_To_resource_DeviceAllocationConfiguration(a.(*resourcev1beta2.DeviceAllocationConfiguration), b.(*resource.DeviceAllocationConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceAllocationConfiguration)(nil), (*resourcev1beta2.DeviceAllocationConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(a.(*resource.DeviceAllocationConfiguration), b.(*resourcev1beta2.DeviceAllocationConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceAllocationResult)(nil), (*resource.DeviceAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult(a.(*resourcev1beta2.DeviceAllocationResult), b.(*resource.DeviceAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceAllocationResult)(nil), (*resourcev1beta2.DeviceAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(a.(*resource.DeviceAllocationResult), b.(*resourcev1beta2.DeviceAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceAttribute)(nil), (*resource.DeviceAttribute)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAttribute_To_resource_DeviceAttribute(a.(*resourcev1beta2.DeviceAttribute), b.(*resource.DeviceAttribute), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceAttribute)(nil), (*resourcev1beta2.DeviceAttribute)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceAttribute_To_v1beta2_DeviceAttribute(a.(*resource.DeviceAttribute), b.(*resourcev1beta2.DeviceAttribute), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceCapacity)(nil), (*resource.DeviceCapacity)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceCapacity_To_resource_DeviceCapacity(a.(*resourcev1beta2.DeviceCapacity), b.(*resource.DeviceCapacity), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceCapacity)(nil), (*resourcev1beta2.DeviceCapacity)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceCapacity_To_v1beta2_DeviceCapacity(a.(*resource.DeviceCapacity), b.(*resourcev1beta2.DeviceCapacity), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClaim)(nil), (*resource.DeviceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClaim_To_resource_DeviceClaim(a.(*resourcev1beta2.DeviceClaim), b.(*resource.DeviceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClaim)(nil), (*resourcev1beta2.DeviceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClaim_To_v1beta2_DeviceClaim(a.(*resource.DeviceClaim), b.(*resourcev1beta2.DeviceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClaimConfiguration)(nil), (*resource.DeviceClaimConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClaimConfiguration_To_resource_DeviceClaimConfiguration(a.(*resourcev1beta2.DeviceClaimConfiguration), b.(*resource.DeviceClaimConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClaimConfiguration)(nil), (*resourcev1beta2.DeviceClaimConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(a.(*resource.DeviceClaimConfiguration), b.(*resourcev1beta2.DeviceClaimConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClass)(nil), (*resource.DeviceClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClass_To_resource_DeviceClass(a.(*resourcev1beta2.DeviceClass), b.(*resource.DeviceClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClass)(nil), (*resourcev1beta2.DeviceClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClass_To_v1beta2_DeviceClass(a.(*resource.DeviceClass), b.(*resourcev1beta2.DeviceClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClassConfiguration)(nil), (*resource.DeviceClassConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassConfiguration_To_resource_DeviceClassConfiguration(a.(*resourcev1beta2.DeviceClassConfiguration), b.(*resource.DeviceClassConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClassConfiguration)(nil), (*resourcev1beta2.DeviceClassConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(a.(*resource.DeviceClassConfiguration), b.(*resourcev1beta2.DeviceClassConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClassList)(nil), (*resource.DeviceClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassList_To_resource_DeviceClassList(a.(*resourcev1beta2.DeviceClassList), b.(*resource.DeviceClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClassList)(nil), (*resourcev1beta2.DeviceClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClassList_To_v1beta2_DeviceClassList(a.(*resource.DeviceClassList), b.(*resourcev1beta2.DeviceClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceClassSpec)(nil), (*resource.DeviceClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec(a.(*resourcev1beta2.DeviceClassSpec), b.(*resource.DeviceClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceClassSpec)(nil), (*resourcev1beta2.DeviceClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec(a.(*resource.DeviceClassSpec), b.(*resourcev1beta2.DeviceClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceConfiguration)(nil), (*resource.DeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(a.(*resourcev1beta2.DeviceConfiguration), b.(*resource.DeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceConfiguration)(nil), (*resourcev1beta2.DeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(a.(*resource.DeviceConfiguration), b.(*resourcev1beta2.DeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceConstraint)(nil), (*resource.DeviceConstraint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceConstraint_To_resource_DeviceConstraint(a.(*resourcev1beta2.DeviceConstraint), b.(*resource.DeviceConstraint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceConstraint)(nil), (*resourcev1beta2.DeviceConstraint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceConstraint_To_v1beta2_DeviceConstraint(a.(*resource.DeviceConstraint), b.(*resourcev1beta2.DeviceConstraint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceCounterConsumption)(nil), (*resource.DeviceCounterConsumption)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceCounterConsumption_To_resource_DeviceCounterConsumption(a.(*resourcev1beta2.DeviceCounterConsumption), b.(*resource.DeviceCounterConsumption), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceCounterConsumption)(nil), (*resourcev1beta2.DeviceCounterConsumption)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(a.(*resource.DeviceCounterConsumption), b.(*resourcev1beta2.DeviceCounterConsumption), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceRequest)(nil), (*resource.DeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceRequest_To_resource_DeviceRequest(a.(*resourcev1beta2.DeviceRequest), b.(*resource.DeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceRequest)(nil), (*resourcev1beta2.DeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceRequest_To_v1beta2_DeviceRequest(a.(*resource.DeviceRequest), b.(*resourcev1beta2.DeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceRequestAllocationResult)(nil), (*resource.DeviceRequestAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceRequestAllocationResult_To_resource_DeviceRequestAllocationResult(a.(*resourcev1beta2.DeviceRequestAllocationResult), b.(*resource.DeviceRequestAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceRequestAllocationResult)(nil), (*resourcev1beta2.DeviceRequestAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(a.(*resource.DeviceRequestAllocationResult), b.(*resourcev1beta2.DeviceRequestAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceSelector)(nil), (*resource.DeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceSelector_To_resource_DeviceSelector(a.(*resourcev1beta2.DeviceSelector), b.(*resource.DeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceSelector)(nil), (*resourcev1beta2.DeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceSelector_To_v1beta2_DeviceSelector(a.(*resource.DeviceSelector), b.(*resourcev1beta2.DeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceSubRequest)(nil), (*resource.DeviceSubRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceSubRequest_To_resource_DeviceSubRequest(a.(*resourcev1beta2.DeviceSubRequest), b.(*resource.DeviceSubRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceSubRequest)(nil), (*resourcev1beta2.DeviceSubRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceSubRequest_To_v1beta2_DeviceSubRequest(a.(*resource.DeviceSubRequest), b.(*resourcev1beta2.DeviceSubRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceTaint)(nil), (*resource.DeviceTaint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceTaint_To_resource_DeviceTaint(a.(*resourcev1beta2.DeviceTaint), b.(*resource.DeviceTaint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceTaint)(nil), (*resourcev1beta2.DeviceTaint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceTaint_To_v1beta2_DeviceTaint(a.(*resource.DeviceTaint), b.(*resourcev1beta2.DeviceTaint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.DeviceToleration)(nil), (*resource.DeviceToleration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceToleration_To_resource_DeviceToleration(a.(*resourcev1beta2.DeviceToleration), b.(*resource.DeviceToleration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.DeviceToleration)(nil), (*resourcev1beta2.DeviceToleration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_DeviceToleration_To_v1beta2_DeviceToleration(a.(*resource.DeviceToleration), b.(*resourcev1beta2.DeviceToleration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ExactDeviceRequest)(nil), (*resource.ExactDeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ExactDeviceRequest_To_resource_ExactDeviceRequest(a.(*resourcev1beta2.ExactDeviceRequest), b.(*resource.ExactDeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ExactDeviceRequest)(nil), (*resourcev1beta2.ExactDeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ExactDeviceRequest_To_v1beta2_ExactDeviceRequest(a.(*resource.ExactDeviceRequest), b.(*resourcev1beta2.ExactDeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.NetworkDeviceData)(nil), (*resource.NetworkDeviceData)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkDeviceData_To_resource_NetworkDeviceData(a.(*resourcev1beta2.NetworkDeviceData), b.(*resource.NetworkDeviceData), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.NetworkDeviceData)(nil), (*resourcev1beta2.NetworkDeviceData)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_NetworkDeviceData_To_v1beta2_NetworkDeviceData(a.(*resource.NetworkDeviceData), b.(*resourcev1beta2.NetworkDeviceData), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.OpaqueDeviceConfiguration)(nil), (*resource.OpaqueDeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_OpaqueDeviceConfiguration_To_resource_OpaqueDeviceConfiguration(a.(*resourcev1beta2.OpaqueDeviceConfiguration), b.(*resource.OpaqueDeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.OpaqueDeviceConfiguration)(nil), (*resourcev1beta2.OpaqueDeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(a.(*resource.OpaqueDeviceConfiguration), b.(*resourcev1beta2.OpaqueDeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaim)(nil), (*resource.ResourceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaim_To_resource_ResourceClaim(a.(*resourcev1beta2.ResourceClaim), b.(*resource.ResourceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaim)(nil), (*resourcev1beta2.ResourceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaim_To_v1beta2_ResourceClaim(a.(*resource.ResourceClaim), b.(*resourcev1beta2.ResourceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimConsumerReference)(nil), (*resource.ResourceClaimConsumerReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimConsumerReference_To_resource_ResourceClaimConsumerReference(a.(*resourcev1beta2.ResourceClaimConsumerReference), b.(*resource.ResourceClaimConsumerReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimConsumerReference)(nil), (*resourcev1beta2.ResourceClaimConsumerReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(a.(*resource.ResourceClaimConsumerReference), b.(*resourcev1beta2.ResourceClaimConsumerReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimList)(nil), (*resource.ResourceClaimList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimList_To_resource_ResourceClaimList(a.(*resourcev1beta2.ResourceClaimList), b.(*resource.ResourceClaimList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimList)(nil), (*resourcev1beta2.ResourceClaimList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimList_To_v1beta2_ResourceClaimList(a.(*resource.ResourceClaimList), b.(*resourcev1beta2.ResourceClaimList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimSpec)(nil), (*resource.ResourceClaimSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(a.(*resourcev1beta2.ResourceClaimSpec), b.(*resource.ResourceClaimSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimSpec)(nil), (*resourcev1beta2.ResourceClaimSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(a.(*resource.ResourceClaimSpec), b.(*resourcev1beta2.ResourceClaimSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimStatus)(nil), (*resource.ResourceClaimStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus(a.(*resourcev1beta2.ResourceClaimStatus), b.(*resource.ResourceClaimStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimStatus)(nil), (*resourcev1beta2.ResourceClaimStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(a.(*resource.ResourceClaimStatus), b.(*resourcev1beta2.ResourceClaimStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimTemplate)(nil), (*resource.ResourceClaimTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplate_To_resource_ResourceClaimTemplate(a.(*resourcev1beta2.ResourceClaimTemplate), b.(*resource.ResourceClaimTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimTemplate)(nil), (*resourcev1beta2.ResourceClaimTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(a.(*resource.ResourceClaimTemplate), b.(*resourcev1beta2.ResourceClaimTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimTemplateList)(nil), (*resource.ResourceClaimTemplateList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplateList_To_resource_ResourceClaimTemplateList(a.(*resourcev1beta2.ResourceClaimTemplateList), b.(*resource.ResourceClaimTemplateList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimTemplateList)(nil), (*resourcev1beta2.ResourceClaimTemplateList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(a.(*resource.ResourceClaimTemplateList), b.(*resourcev1beta2.ResourceClaimTemplateList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceClaimTemplateSpec)(nil), (*resource.ResourceClaimTemplateSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec(a.(*resourcev1beta2.ResourceClaimTemplateSpec), b.(*resource.ResourceClaimTemplateSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceClaimTemplateSpec)(nil), (*resourcev1beta2.ResourceClaimTemplateSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(a.(*resource.ResourceClaimTemplateSpec), b.(*resourcev1beta2.ResourceClaimTemplateSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourcePool)(nil), (*resource.ResourcePool)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourcePool_To_resource_ResourcePool(a.(*resourcev1beta2.ResourcePool), b.(*resource.ResourcePool), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourcePool)(nil), (*resourcev1beta2.ResourcePool)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourcePool_To_v1beta2_ResourcePool(a.(*resource.ResourcePool), b.(*resourcev1beta2.ResourcePool), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceSlice)(nil), (*resource.ResourceSlice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSlice_To_resource_ResourceSlice(a.(*resourcev1beta2.ResourceSlice), b.(*resource.ResourceSlice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceSlice)(nil), (*resourcev1beta2.ResourceSlice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceSlice_To_v1beta2_ResourceSlice(a.(*resource.ResourceSlice), b.(*resourcev1beta2.ResourceSlice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceSliceList)(nil), (*resource.ResourceSliceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSliceList_To_resource_ResourceSliceList(a.(*resourcev1beta2.ResourceSliceList), b.(*resource.ResourceSliceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceSliceList)(nil), (*resourcev1beta2.ResourceSliceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceSliceList_To_v1beta2_ResourceSliceList(a.(*resource.ResourceSliceList), b.(*resourcev1beta2.ResourceSliceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta2.ResourceSliceSpec)(nil), (*resource.ResourceSliceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec(a.(*resourcev1beta2.ResourceSliceSpec), b.(*resource.ResourceSliceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resource.ResourceSliceSpec)(nil), (*resourcev1beta2.ResourceSliceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(a.(*resource.ResourceSliceSpec), b.(*resourcev1beta2.ResourceSliceSpec), scope)
	}); err != nil {
		return err
	}
	return nil
}

func autoConvert_v1beta2_AllocatedDeviceStatus_To_resource_AllocatedDeviceStatus(in *resourcev1beta2.AllocatedDeviceStatus, out *resource.AllocatedDeviceStatus, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.Conditions = *(*[]v1.Condition)(unsafe.Pointer(&in.Conditions))
	out.Data = (*runtime.RawExtension)(unsafe.Pointer(in.Data))
	out.NetworkData = (*resource.NetworkDeviceData)(unsafe.Pointer(in.NetworkData))
	return nil
}

// Convert_v1beta2_AllocatedDeviceStatus_To_resource_AllocatedDeviceStatus is an autogenerated conversion function.
func Convert_v1beta2_AllocatedDeviceStatus_To_resource_AllocatedDeviceStatus(in *resourcev1beta2.AllocatedDeviceStatus, out *resource.AllocatedDeviceStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_AllocatedDeviceStatus_To_resource_AllocatedDeviceStatus(in, out, s)
}

func autoConvert_resource_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in *resource.AllocatedDeviceStatus, out *resourcev1beta2.AllocatedDeviceStatus, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.Conditions = *(*[]v1.Condition)(unsafe.Pointer(&in.Conditions))
	out.Data = (*runtime.RawExtension)(unsafe.Pointer(in.Data))
	out.NetworkData = (*resourcev1beta2.NetworkDeviceData)(unsafe.Pointer(in.NetworkData))
	return nil
}

// Convert_resource_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus is an autogenerated conversion function.
func Convert_resource_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in *resource.AllocatedDeviceStatus, out *resourcev1beta2.AllocatedDeviceStatus, s conversion.Scope) error {
	return autoConvert_resource_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in, out, s)
}

func autoConvert_v1beta2_AllocationResult_To_resource_AllocationResult(in *resourcev1beta2.AllocationResult, out *resource.AllocationResult, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	out.NodeSelector = (*core.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	return nil
}

// Convert_v1beta2_AllocationResult_To_resource_AllocationResult is an autogenerated conversion function.
func Convert_v1beta2_AllocationResult_To_resource_AllocationResult(in *resourcev1beta2.AllocationResult, out *resource.AllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_AllocationResult_To_resource_AllocationResult(in, out, s)
}

func autoConvert_resource_AllocationResult_To_v1beta2_AllocationResult(in *resource.AllocationResult, out *resourcev1beta2.AllocationResult, s conversion.Scope) error {
	if err := Convert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	return nil
}

// Convert_resource_AllocationResult_To_v1beta2_AllocationResult is an autogenerated conversion function.
func Convert_resource_AllocationResult_To_v1beta2_AllocationResult(in *resource.AllocationResult, out *resourcev1beta2.AllocationResult, s conversion.Scope) error {
	return autoConvert_resource_AllocationResult_To_v1beta2_AllocationResult(in, out, s)
}

func autoConvert_v1beta2_CELDeviceSelector_To_resource_CELDeviceSelector(in *resourcev1beta2.CELDeviceSelector, out *resource.CELDeviceSelector, s conversion.Scope) error {
	out.Expression = in.Expression
	return nil
}

// Convert_v1beta2_CELDeviceSelector_To_resource_CELDeviceSelector is an autogenerated conversion function.
func Convert_v1beta2_CELDeviceSelector_To_resource_CELDeviceSelector(in *resourcev1beta2.CELDeviceSelector, out *resource.CELDeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta2_CELDeviceSelector_To_resource_CELDeviceSelector(in, out, s)
}

func autoConvert_resource_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in *resource.CELDeviceSelector, out *resourcev1beta2.CELDeviceSelector, s conversion.Scope) error {
	out.Expression = in.Expression
	return nil
}

// Convert_resource_CELDeviceSelector_To_v1beta2_CELDeviceSelector is an autogenerated conversion function.
func Convert_resource_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in *resource.CELDeviceSelector, out *resourcev1beta2.CELDeviceSelector, s conversion.Scope) error {
	return autoConvert_resource_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in, out, s)
}

func autoConvert_v1beta2_Counter_To_resource_Counter(in *resourcev1beta2.Counter, out *resource.Counter, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta2_Counter_To_resource_Counter is an autogenerated conversion function.
func Convert_v1beta2_Counter_To_resource_Counter(in *resourcev1beta2.Counter, out *resource.Counter, s conversion.Scope) error {
	return autoConvert_v1beta2_Counter_To_resource_Counter(in, out, s)
}

func autoConvert_resource_Counter_To_v1beta2_Counter(in *resource.Counter, out *resourcev1beta2.Counter, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_resource_Counter_To_v1beta2_Counter is an autogenerated conversion function.
func Convert_resource_Counter_To_v1beta2_Counter(in *resource.Counter, out *resourcev1beta2.Counter, s conversion.Scope) error {
	return autoConvert_resource_Counter_To_v1beta2_Counter(in, out, s)
}

func autoConvert_v1beta2_CounterSet_To_resource_CounterSet(in *resourcev1beta2.CounterSet, out *resource.CounterSet, s conversion.Scope) error {
	out.Name = in.Name
	out.Counters = *(*map[string]resource.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta2_CounterSet_To_resource_CounterSet is an autogenerated conversion function.
func Convert_v1beta2_CounterSet_To_resource_CounterSet(in *resourcev1beta2.CounterSet, out *resource.CounterSet, s conversion.Scope) error {
	return autoConvert_v1beta2_CounterSet_To_resource_CounterSet(in, out, s)
}

func autoConvert_resource_CounterSet_To_v1beta2_CounterSet(in *resource.CounterSet, out *resourcev1beta2.CounterSet, s conversion.Scope) error {
	out.Name = in.Name
	out.Counters = *(*map[string]resourcev1beta2.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_resource_CounterSet_To_v1beta2_CounterSet is an autogenerated conversion function.
func Convert_resource_CounterSet_To_v1beta2_CounterSet(in *resource.CounterSet, out *resourcev1beta2.CounterSet, s conversion.Scope) error {
	return autoConvert_resource_CounterSet_To_v1beta2_CounterSet(in, out, s)
}

func autoConvert_v1beta2_Device_To_resource_Device(in *resourcev1beta2.Device, out *resource.Device, s conversion.Scope) error {
	out.Name = in.Name
	out.Attributes = *(*map[resource.QualifiedName]resource.DeviceAttribute)(unsafe.Pointer(&in.Attributes))
	out.Capacity = *(*map[resource.QualifiedName]resource.DeviceCapacity)(unsafe.Pointer(&in.Capacity))
	out.ConsumesCounters = *(*[]resource.DeviceCounterConsumption)(unsafe.Pointer(&in.ConsumesCounters))
	out.NodeName = (*string)(unsafe.Pointer(in.NodeName))
	out.NodeSelector = (*core.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	out.AllNodes = (*bool)(unsafe.Pointer(in.AllNodes))
	out.Taints = *(*[]resource.DeviceTaint)(unsafe.Pointer(&in.Taints))
	return nil
}

// Convert_v1beta2_Device_To_resource_Device is an autogenerated conversion function.
func Convert_v1beta2_Device_To_resource_Device(in *resourcev1beta2.Device, out *resource.Device, s conversion.Scope) error {
	return autoConvert_v1beta2_Device_To_resource_Device(in, out, s)
}

func autoConvert_resource_Device_To_v1beta2_Device(in *resource.Device, out *resourcev1beta2.Device, s conversion.Scope) error {
	out.Name = in.Name
	out.Attributes = *(*map[resourcev1beta2.QualifiedName]resourcev1beta2.DeviceAttribute)(unsafe.Pointer(&in.Attributes))
	out.Capacity = *(*map[resourcev1beta2.QualifiedName]resourcev1beta2.DeviceCapacity)(unsafe.Pointer(&in.Capacity))
	out.ConsumesCounters = *(*[]resourcev1beta2.DeviceCounterConsumption)(unsafe.Pointer(&in.ConsumesCounters))
	out.NodeName = (*string)(unsafe.Pointer(in.NodeName))
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	out.AllNodes = (*bool)(unsafe.Pointer(in.AllNodes))
	out.Taints = *(*[]resourcev1beta2.DeviceTaint)(unsafe.Pointer(&in.Taints))
	return nil
}

// Convert_resource_Device_To_v1beta2_Device is an autogenerated conversion function.
func Convert_resource_Device_To_v1beta2_Device(in *resource.Device, out *resourcev1beta2.Device, s conversion.Scope) error {
	return autoConvert_resource_Device_To_v1beta2_Device(in, out, s)
}

func autoConvert_v1beta2_DeviceAllocationConfiguration_To_resource_DeviceAllocationConfiguration(in *resourcev1beta2.DeviceAllocationConfiguration, out *resource.DeviceAllocationConfiguration, s conversion.Scope) error {
	out.Source = resource.AllocationConfigSource(in.Source)
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceAllocationConfiguration_To_resource_DeviceAllocationConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceAllocationConfiguration_To_resource_DeviceAllocationConfiguration(in *resourcev1beta2.DeviceAllocationConfiguration, out *resource.DeviceAllocationConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAllocationConfiguration_To_resource_DeviceAllocationConfiguration(in, out, s)
}

func autoConvert_resource_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in *resource.DeviceAllocationConfiguration, out *resourcev1beta2.DeviceAllocationConfiguration, s conversion.Scope) error {
	out.Source = resourcev1beta2.AllocationConfigSource(in.Source)
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration is an autogenerated conversion function.
func Convert_resource_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in *resource.DeviceAllocationConfiguration, out *resourcev1beta2.DeviceAllocationConfiguration, s conversion.Scope) error {
	return autoConvert_resource_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult(in *resourcev1beta2.DeviceAllocationResult, out *resource.DeviceAllocationResult, s conversion.Scope) error {
	out.Results = *(*[]resource.DeviceRequestAllocationResult)(unsafe.Pointer(&in.Results))
	out.Config = *(*[]resource.DeviceAllocationConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult is an autogenerated conversion function.
func Convert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult(in *resourcev1beta2.DeviceAllocationResult, out *resource.DeviceAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAllocationResult_To_resource_DeviceAllocationResult(in, out, s)
}

func autoConvert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in *resource.DeviceAllocationResult, out *resourcev1beta2.DeviceAllocationResult, s conversion.Scope) error {
	out.Results = *(*[]resourcev1beta2.DeviceRequestAllocationResult)(unsafe.Pointer(&in.Results))
	out.Config = *(*[]resourcev1beta2.DeviceAllocationConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult is an autogenerated conversion function.
func Convert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in *resource.DeviceAllocationResult, out *resourcev1beta2.DeviceAllocationResult, s conversion.Scope) error {
	return autoConvert_resource_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in, out, s)
}

func autoConvert_v1beta2_DeviceAttribute_To_resource_DeviceAttribute(in *resourcev1beta2.DeviceAttribute, out *resource.DeviceAttribute, s conversion.Scope) error {
	out.IntValue = (*int64)(unsafe.Pointer(in.IntValue))
	out.BoolValue = (*bool)(unsafe.Pointer(in.BoolValue))
	out.StringValue = (*string)(unsafe.Pointer(in.StringValue))
	out.VersionValue = (*string)(unsafe.Pointer(in.VersionValue))
	return nil
}

// Convert_v1beta2_DeviceAttribute_To_resource_DeviceAttribute is an autogenerated conversion function.
func Convert_v1beta2_DeviceAttribute_To_resource_DeviceAttribute(in *resourcev1beta2.DeviceAttribute, out *resource.DeviceAttribute, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAttribute_To_resource_DeviceAttribute(in, out, s)
}

func autoConvert_resource_DeviceAttribute_To_v1beta2_DeviceAttribute(in *resource.DeviceAttribute, out *resourcev1beta2.DeviceAttribute, s conversion.Scope) error {
	out.IntValue = (*int64)(unsafe.Pointer(in.IntValue))
	out.BoolValue = (*bool)(unsafe.Pointer(in.BoolValue))
	out.StringValue = (*string)(unsafe.Pointer(in.StringValue))
	out.VersionValue = (*string)(unsafe.Pointer(in.VersionValue))
	return nil
}

// Convert_resource_DeviceAttribute_To_v1beta2_DeviceAttribute is an autogenerated conversion function.
func Convert_resource_DeviceAttribute_To_v1beta2_DeviceAttribute(in *resource.DeviceAttribute, out *resourcev1beta2.DeviceAttribute, s conversion.Scope) error {
	return autoConvert_resource_DeviceAttribute_To_v1beta2_DeviceAttribute(in, out, s)
}

func autoConvert_v1beta2_DeviceCapacity_To_resource_DeviceCapacity(in *resourcev1beta2.DeviceCapacity, out *resource.DeviceCapacity, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta2_DeviceCapacity_To_resource_DeviceCapacity is an autogenerated conversion function.
func Convert_v1beta2_DeviceCapacity_To_resource_DeviceCapacity(in *resourcev1beta2.DeviceCapacity, out *resource.DeviceCapacity, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceCapacity_To_resource_DeviceCapacity(in, out, s)
}

func autoConvert_resource_DeviceCapacity_To_v1beta2_DeviceCapacity(in *resource.DeviceCapacity, out *resourcev1beta2.DeviceCapacity, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_resource_DeviceCapacity_To_v1beta2_DeviceCapacity is an autogenerated conversion function.
func Convert_resource_DeviceCapacity_To_v1beta2_DeviceCapacity(in *resource.DeviceCapacity, out *resourcev1beta2.DeviceCapacity, s conversion.Scope) error {
	return autoConvert_resource_DeviceCapacity_To_v1beta2_DeviceCapacity(in, out, s)
}

func autoConvert_v1beta2_DeviceClaim_To_resource_DeviceClaim(in *resourcev1beta2.DeviceClaim, out *resource.DeviceClaim, s conversion.Scope) error {
	out.Requests = *(*[]resource.DeviceRequest)(unsafe.Pointer(&in.Requests))
	out.Constraints = *(*[]resource.DeviceConstraint)(unsafe.Pointer(&in.Constraints))
	out.Config = *(*[]resource.DeviceClaimConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceClaim_To_resource_DeviceClaim is an autogenerated conversion function.
func Convert_v1beta2_DeviceClaim_To_resource_DeviceClaim(in *resourcev1beta2.DeviceClaim, out *resource.DeviceClaim, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClaim_To_resource_DeviceClaim(in, out, s)
}

func autoConvert_resource_DeviceClaim_To_v1beta2_DeviceClaim(in *resource.DeviceClaim, out *resourcev1beta2.DeviceClaim, s conversion.Scope) error {
	out.Requests = *(*[]resourcev1beta2.DeviceRequest)(unsafe.Pointer(&in.Requests))
	out.Constraints = *(*[]resourcev1beta2.DeviceConstraint)(unsafe.Pointer(&in.Constraints))
	out.Config = *(*[]resourcev1beta2.DeviceClaimConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_resource_DeviceClaim_To_v1beta2_DeviceClaim is an autogenerated conversion function.
func Convert_resource_DeviceClaim_To_v1beta2_DeviceClaim(in *resource.DeviceClaim, out *resourcev1beta2.DeviceClaim, s conversion.Scope) error {
	return autoConvert_resource_DeviceClaim_To_v1beta2_DeviceClaim(in, out, s)
}

func autoConvert_v1beta2_DeviceClaimConfiguration_To_resource_DeviceClaimConfiguration(in *resourcev1beta2.DeviceClaimConfiguration, out *resource.DeviceClaimConfiguration, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClaimConfiguration_To_resource_DeviceClaimConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceClaimConfiguration_To_resource_DeviceClaimConfiguration(in *resourcev1beta2.DeviceClaimConfiguration, out *resource.DeviceClaimConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClaimConfiguration_To_resource_DeviceClaimConfiguration(in, out, s)
}

func autoConvert_resource_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in *resource.DeviceClaimConfiguration, out *resourcev1beta2.DeviceClaimConfiguration, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration is an autogenerated conversion function.
func Convert_resource_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in *resource.DeviceClaimConfiguration, out *resourcev1beta2.DeviceClaimConfiguration, s conversion.Scope) error {
	return autoConvert_resource_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceClass_To_resource_DeviceClass(in *resourcev1beta2.DeviceClass, out *resource.DeviceClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClass_To_resource_DeviceClass is an autogenerated conversion function.
func Convert_v1beta2_DeviceClass_To_resource_DeviceClass(in *resourcev1beta2.DeviceClass, out *resource.DeviceClass, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClass_To_resource_DeviceClass(in, out, s)
}

func autoConvert_resource_DeviceClass_To_v1beta2_DeviceClass(in *resource.DeviceClass, out *resourcev1beta2.DeviceClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_DeviceClass_To_v1beta2_DeviceClass is an autogenerated conversion function.
func Convert_resource_DeviceClass_To_v1beta2_DeviceClass(in *resource.DeviceClass, out *resourcev1beta2.DeviceClass, s conversion.Scope) error {
	return autoConvert_resource_DeviceClass_To_v1beta2_DeviceClass(in, out, s)
}

func autoConvert_v1beta2_DeviceClassConfiguration_To_resource_DeviceClassConfiguration(in *resourcev1beta2.DeviceClassConfiguration, out *resource.DeviceClassConfiguration, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClassConfiguration_To_resource_DeviceClassConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassConfiguration_To_resource_DeviceClassConfiguration(in *resourcev1beta2.DeviceClassConfiguration, out *resource.DeviceClassConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassConfiguration_To_resource_DeviceClassConfiguration(in, out, s)
}

func autoConvert_resource_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in *resource.DeviceClassConfiguration, out *resourcev1beta2.DeviceClassConfiguration, s conversion.Scope) error {
	if err := Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration is an autogenerated conversion function.
func Convert_resource_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in *resource.DeviceClassConfiguration, out *resourcev1beta2.DeviceClassConfiguration, s conversion.Scope) error {
	return autoConvert_resource_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceClassList_To_resource_DeviceClassList(in *resourcev1beta2.DeviceClassList, out *resource.DeviceClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resource.DeviceClass)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_DeviceClassList_To_resource_DeviceClassList is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassList_To_resource_DeviceClassList(in *resourcev1beta2.DeviceClassList, out *resource.DeviceClassList, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassList_To_resource_DeviceClassList(in, out, s)
}

func autoConvert_resource_DeviceClassList_To_v1beta2_DeviceClassList(in *resource.DeviceClassList, out *resourcev1beta2.DeviceClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resourcev1beta2.DeviceClass)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_resource_DeviceClassList_To_v1beta2_DeviceClassList is an autogenerated conversion function.
func Convert_resource_DeviceClassList_To_v1beta2_DeviceClassList(in *resource.DeviceClassList, out *resourcev1beta2.DeviceClassList, s conversion.Scope) error {
	return autoConvert_resource_DeviceClassList_To_v1beta2_DeviceClassList(in, out, s)
}

func autoConvert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec(in *resourcev1beta2.DeviceClassSpec, out *resource.DeviceClassSpec, s conversion.Scope) error {
	out.Selectors = *(*[]resource.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.Config = *(*[]resource.DeviceClassConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec(in *resourcev1beta2.DeviceClassSpec, out *resource.DeviceClassSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassSpec_To_resource_DeviceClassSpec(in, out, s)
}

func autoConvert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in *resource.DeviceClassSpec, out *resourcev1beta2.DeviceClassSpec, s conversion.Scope) error {
	out.Selectors = *(*[]resourcev1beta2.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.Config = *(*[]resourcev1beta2.DeviceClassConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec is an autogenerated conversion function.
func Convert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in *resource.DeviceClassSpec, out *resourcev1beta2.DeviceClassSpec, s conversion.Scope) error {
	return autoConvert_resource_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in, out, s)
}

func autoConvert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(in *resourcev1beta2.DeviceConfiguration, out *resource.DeviceConfiguration, s conversion.Scope) error {
	out.Opaque = (*resource.OpaqueDeviceConfiguration)(unsafe.Pointer(in.Opaque))
	return nil
}

// Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(in *resourcev1beta2.DeviceConfiguration, out *resource.DeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceConfiguration_To_resource_DeviceConfiguration(in, out, s)
}

func autoConvert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in *resource.DeviceConfiguration, out *resourcev1beta2.DeviceConfiguration, s conversion.Scope) error {
	out.Opaque = (*resourcev1beta2.OpaqueDeviceConfiguration)(unsafe.Pointer(in.Opaque))
	return nil
}

// Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration is an autogenerated conversion function.
func Convert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in *resource.DeviceConfiguration, out *resourcev1beta2.DeviceConfiguration, s conversion.Scope) error {
	return autoConvert_resource_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceConstraint_To_resource_DeviceConstraint(in *resourcev1beta2.DeviceConstraint, out *resource.DeviceConstraint, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	out.MatchAttribute = (*resource.FullyQualifiedName)(unsafe.Pointer(in.MatchAttribute))
	return nil
}

// Convert_v1beta2_DeviceConstraint_To_resource_DeviceConstraint is an autogenerated conversion function.
func Convert_v1beta2_DeviceConstraint_To_resource_DeviceConstraint(in *resourcev1beta2.DeviceConstraint, out *resource.DeviceConstraint, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceConstraint_To_resource_DeviceConstraint(in, out, s)
}

func autoConvert_resource_DeviceConstraint_To_v1beta2_DeviceConstraint(in *resource.DeviceConstraint, out *resourcev1beta2.DeviceConstraint, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	out.MatchAttribute = (*resourcev1beta2.FullyQualifiedName)(unsafe.Pointer(in.MatchAttribute))
	return nil
}

// Convert_resource_DeviceConstraint_To_v1beta2_DeviceConstraint is an autogenerated conversion function.
func Convert_resource_DeviceConstraint_To_v1beta2_DeviceConstraint(in *resource.DeviceConstraint, out *resourcev1beta2.DeviceConstraint, s conversion.Scope) error {
	return autoConvert_resource_DeviceConstraint_To_v1beta2_DeviceConstraint(in, out, s)
}

func autoConvert_v1beta2_DeviceCounterConsumption_To_resource_DeviceCounterConsumption(in *resourcev1beta2.DeviceCounterConsumption, out *resource.DeviceCounterConsumption, s conversion.Scope) error {
	out.CounterSet = in.CounterSet
	out.Counters = *(*map[string]resource.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta2_DeviceCounterConsumption_To_resource_DeviceCounterConsumption is an autogenerated conversion function.
func Convert_v1beta2_DeviceCounterConsumption_To_resource_DeviceCounterConsumption(in *resourcev1beta2.DeviceCounterConsumption, out *resource.DeviceCounterConsumption, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceCounterConsumption_To_resource_DeviceCounterConsumption(in, out, s)
}

func autoConvert_resource_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in *resource.DeviceCounterConsumption, out *resourcev1beta2.DeviceCounterConsumption, s conversion.Scope) error {
	out.CounterSet = in.CounterSet
	out.Counters = *(*map[string]resourcev1beta2.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_resource_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption is an autogenerated conversion function.
func Convert_resource_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in *resource.DeviceCounterConsumption, out *resourcev1beta2.DeviceCounterConsumption, s conversion.Scope) error {
	return autoConvert_resource_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in, out, s)
}

func autoConvert_v1beta2_DeviceRequest_To_resource_DeviceRequest(in *resourcev1beta2.DeviceRequest, out *resource.DeviceRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.Exactly = (*resource.ExactDeviceRequest)(unsafe.Pointer(in.Exactly))
	out.FirstAvailable = *(*[]resource.DeviceSubRequest)(unsafe.Pointer(&in.FirstAvailable))
	return nil
}

// Convert_v1beta2_DeviceRequest_To_resource_DeviceRequest is an autogenerated conversion function.
func Convert_v1beta2_DeviceRequest_To_resource_DeviceRequest(in *resourcev1beta2.DeviceRequest, out *resource.DeviceRequest, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceRequest_To_resource_DeviceRequest(in, out, s)
}

func autoConvert_resource_DeviceRequest_To_v1beta2_DeviceRequest(in *resource.DeviceRequest, out *resourcev1beta2.DeviceRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.Exactly = (*resourcev1beta2.ExactDeviceRequest)(unsafe.Pointer(in.Exactly))
	out.FirstAvailable = *(*[]resourcev1beta2.DeviceSubRequest)(unsafe.Pointer(&in.FirstAvailable))
	return nil
}

// Convert_resource_DeviceRequest_To_v1beta2_DeviceRequest is an autogenerated conversion function.
func Convert_resource_DeviceRequest_To_v1beta2_DeviceRequest(in *resource.DeviceRequest, out *resourcev1beta2.DeviceRequest, s conversion.Scope) error {
	return autoConvert_resource_DeviceRequest_To_v1beta2_DeviceRequest(in, out, s)
}

func autoConvert_v1beta2_DeviceRequestAllocationResult_To_resource_DeviceRequestAllocationResult(in *resourcev1beta2.DeviceRequestAllocationResult, out *resource.DeviceRequestAllocationResult, s conversion.Scope) error {
	out.Request = in.Request
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]resource.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta2_DeviceRequestAllocationResult_To_resource_DeviceRequestAllocationResult is an autogenerated conversion function.
func Convert_v1beta2_DeviceRequestAllocationResult_To_resource_DeviceRequestAllocationResult(in *resourcev1beta2.DeviceRequestAllocationResult, out *resource.DeviceRequestAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceRequestAllocationResult_To_resource_DeviceRequestAllocationResult(in, out, s)
}

func autoConvert_resource_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in *resource.DeviceRequestAllocationResult, out *resourcev1beta2.DeviceRequestAllocationResult, s conversion.Scope) error {
	out.Request = in.Request
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]resourcev1beta2.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_resource_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult is an autogenerated conversion function.
func Convert_resource_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in *resource.DeviceRequestAllocationResult, out *resourcev1beta2.DeviceRequestAllocationResult, s conversion.Scope) error {
	return autoConvert_resource_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in, out, s)
}

func autoConvert_v1beta2_DeviceSelector_To_resource_DeviceSelector(in *resourcev1beta2.DeviceSelector, out *resource.DeviceSelector, s conversion.Scope) error {
	out.CEL = (*resource.CELDeviceSelector)(unsafe.Pointer(in.CEL))
	return nil
}

// Convert_v1beta2_DeviceSelector_To_resource_DeviceSelector is an autogenerated conversion function.
func Convert_v1beta2_DeviceSelector_To_resource_DeviceSelector(in *resourcev1beta2.DeviceSelector, out *resource.DeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceSelector_To_resource_DeviceSelector(in, out, s)
}

func autoConvert_resource_DeviceSelector_To_v1beta2_DeviceSelector(in *resource.DeviceSelector, out *resourcev1beta2.DeviceSelector, s conversion.Scope) error {
	out.CEL = (*resourcev1beta2.CELDeviceSelector)(unsafe.Pointer(in.CEL))
	return nil
}

// Convert_resource_DeviceSelector_To_v1beta2_DeviceSelector is an autogenerated conversion function.
func Convert_resource_DeviceSelector_To_v1beta2_DeviceSelector(in *resource.DeviceSelector, out *resourcev1beta2.DeviceSelector, s conversion.Scope) error {
	return autoConvert_resource_DeviceSelector_To_v1beta2_DeviceSelector(in, out, s)
}

func autoConvert_v1beta2_DeviceSubRequest_To_resource_DeviceSubRequest(in *resourcev1beta2.DeviceSubRequest, out *resource.DeviceSubRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]resource.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = resource.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.Tolerations = *(*[]resource.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta2_DeviceSubRequest_To_resource_DeviceSubRequest is an autogenerated conversion function.
func Convert_v1beta2_DeviceSubRequest_To_resource_DeviceSubRequest(in *resourcev1beta2.DeviceSubRequest, out *resource.DeviceSubRequest, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceSubRequest_To_resource_DeviceSubRequest(in, out, s)
}

func autoConvert_resource_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in *resource.DeviceSubRequest, out *resourcev1beta2.DeviceSubRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]resourcev1beta2.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = resourcev1beta2.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.Tolerations = *(*[]resourcev1beta2.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_resource_DeviceSubRequest_To_v1beta2_DeviceSubRequest is an autogenerated conversion function.
func Convert_resource_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in *resource.DeviceSubRequest, out *resourcev1beta2.DeviceSubRequest, s conversion.Scope) error {
	return autoConvert_resource_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in, out, s)
}

func autoConvert_v1beta2_DeviceTaint_To_resource_DeviceTaint(in *resourcev1beta2.DeviceTaint, out *resource.DeviceTaint, s conversion.Scope) error {
	out.Key = in.Key
	out.Value = in.Value
	out.Effect = resource.DeviceTaintEffect(in.Effect)
	out.TimeAdded = (*v1.Time)(unsafe.Pointer(in.TimeAdded))
	return nil
}

// Convert_v1beta2_DeviceTaint_To_resource_DeviceTaint is an autogenerated conversion function.
func Convert_v1beta2_DeviceTaint_To_resource_DeviceTaint(in *resourcev1beta2.DeviceTaint, out *resource.DeviceTaint, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceTaint_To_resource_DeviceTaint(in, out, s)
}

func autoConvert_resource_DeviceTaint_To_v1beta2_DeviceTaint(in *resource.DeviceTaint, out *resourcev1beta2.DeviceTaint, s conversion.Scope) error {
	out.Key = in.Key
	out.Value = in.Value
	out.Effect = resourcev1beta2.DeviceTaintEffect(in.Effect)
	out.TimeAdded = (*v1.Time)(unsafe.Pointer(in.TimeAdded))
	return nil
}

// Convert_resource_DeviceTaint_To_v1beta2_DeviceTaint is an autogenerated conversion function.
func Convert_resource_DeviceTaint_To_v1beta2_DeviceTaint(in *resource.DeviceTaint, out *resourcev1beta2.DeviceTaint, s conversion.Scope) error {
	return autoConvert_resource_DeviceTaint_To_v1beta2_DeviceTaint(in, out, s)
}

func autoConvert_v1beta2_DeviceToleration_To_resource_DeviceToleration(in *resourcev1beta2.DeviceToleration, out *resource.DeviceToleration, s conversion.Scope) error {
	out.Key = in.Key
	out.Operator = resource.DeviceTolerationOperator(in.Operator)
	out.Value = in.Value
	out.Effect = resource.DeviceTaintEffect(in.Effect)
	out.TolerationSeconds = (*int64)(unsafe.Pointer(in.TolerationSeconds))
	return nil
}

// Convert_v1beta2_DeviceToleration_To_resource_DeviceToleration is an autogenerated conversion function.
func Convert_v1beta2_DeviceToleration_To_resource_DeviceToleration(in *resourcev1beta2.DeviceToleration, out *resource.DeviceToleration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceToleration_To_resource_DeviceToleration(in, out, s)
}

func autoConvert_resource_DeviceToleration_To_v1beta2_DeviceToleration(in *resource.DeviceToleration, out *resourcev1beta2.DeviceToleration, s conversion.Scope) error {
	out.Key = in.Key
	out.Operator = resourcev1beta2.DeviceTolerationOperator(in.Operator)
	out.Value = in.Value
	out.Effect = resourcev1beta2.DeviceTaintEffect(in.Effect)
	out.TolerationSeconds = (*int64)(unsafe.Pointer(in.TolerationSeconds))
	return nil
}

// Convert_resource_DeviceToleration_To_v1beta2_DeviceToleration is an autogenerated conversion function.
func Convert_resource_DeviceToleration_To_v1beta2_DeviceToleration(in *resource.DeviceToleration, out *resourcev1beta2.DeviceToleration, s conversion.Scope) error {
	return autoConvert_resource_DeviceToleration_To_v1beta2_DeviceToleration(in, out, s)
}

func autoConvert_v1beta2_ExactDeviceRequest_To_resource_ExactDeviceRequest(in *resourcev1beta2.ExactDeviceRequest, out *resource.ExactDeviceRequest, s conversion.Scope) error {
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]resource.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = resource.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]resource.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta2_ExactDeviceRequest_To_resource_ExactDeviceRequest is an autogenerated conversion function.
func Convert_v1beta2_ExactDeviceRequest_To_resource_ExactDeviceRequest(in *resourcev1beta2.ExactDeviceRequest, out *resource.ExactDeviceRequest, s conversion.Scope) error {
	return autoConvert_v1beta2_ExactDeviceRequest_To_resource_ExactDeviceRequest(in, out, s)
}

func autoConvert_resource_ExactDeviceRequest_To_v1beta2_ExactDeviceRequest(in *resource.ExactDeviceRequest, out *resourcev1beta2.ExactDeviceRequest, s conversion.Scope) error {
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]resourcev1beta2.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = resourcev1beta2.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]resourcev1beta2.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_resource_ExactDeviceRequest_To_v1beta2_ExactDeviceRequest is an autogenerated conversion function.
func Convert_resource_ExactDeviceRequest_To_v1beta2_ExactDeviceRequest(in *resource.ExactDeviceRequest, out *resourcev1beta2.ExactDeviceRequest, s conversion.Scope) error {
	return autoConvert_resource_ExactDeviceRequest_To_v1beta2_ExactDeviceRequest(in, out, s)
}

func autoConvert_v1beta2_NetworkDeviceData_To_resource_NetworkDeviceData(in *resourcev1beta2.NetworkDeviceData, out *resource.NetworkDeviceData, s conversion.Scope) error {
	out.InterfaceName = in.InterfaceName
	out.IPs = *(*[]string)(unsafe.Pointer(&in.IPs))
	out.HardwareAddress = in.HardwareAddress
	return nil
}

// Convert_v1beta2_NetworkDeviceData_To_resource_NetworkDeviceData is an autogenerated conversion function.
func Convert_v1beta2_NetworkDeviceData_To_resource_NetworkDeviceData(in *resourcev1beta2.NetworkDeviceData, out *resource.NetworkDeviceData, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkDeviceData_To_resource_NetworkDeviceData(in, out, s)
}

func autoConvert_resource_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in *resource.NetworkDeviceData, out *resourcev1beta2.NetworkDeviceData, s conversion.Scope) error {
	out.InterfaceName = in.InterfaceName
	out.IPs = *(*[]string)(unsafe.Pointer(&in.IPs))
	out.HardwareAddress = in.HardwareAddress
	return nil
}

// Convert_resource_NetworkDeviceData_To_v1beta2_NetworkDeviceData is an autogenerated conversion function.
func Convert_resource_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in *resource.NetworkDeviceData, out *resourcev1beta2.NetworkDeviceData, s conversion.Scope) error {
	return autoConvert_resource_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in, out, s)
}

func autoConvert_v1beta2_OpaqueDeviceConfiguration_To_resource_OpaqueDeviceConfiguration(in *resourcev1beta2.OpaqueDeviceConfiguration, out *resource.OpaqueDeviceConfiguration, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Parameters = in.Parameters
	return nil
}

// Convert_v1beta2_OpaqueDeviceConfiguration_To_resource_OpaqueDeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta2_OpaqueDeviceConfiguration_To_resource_OpaqueDeviceConfiguration(in *resourcev1beta2.OpaqueDeviceConfiguration, out *resource.OpaqueDeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_OpaqueDeviceConfiguration_To_resource_OpaqueDeviceConfiguration(in, out, s)
}

func autoConvert_resource_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in *resource.OpaqueDeviceConfiguration, out *resourcev1beta2.OpaqueDeviceConfiguration, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Parameters = in.Parameters
	return nil
}

// Convert_resource_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration is an autogenerated conversion function.
func Convert_resource_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in *resource.OpaqueDeviceConfiguration, out *resourcev1beta2.OpaqueDeviceConfiguration, s conversion.Scope) error {
	return autoConvert_resource_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in, out, s)
}

func autoConvert_v1beta2_ResourceClaim_To_resource_ResourceClaim(in *resourcev1beta2.ResourceClaim, out *resource.ResourceClaim, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaim_To_resource_ResourceClaim is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaim_To_resource_ResourceClaim(in *resourcev1beta2.ResourceClaim, out *resource.ResourceClaim, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaim_To_resource_ResourceClaim(in, out, s)
}

func autoConvert_resource_ResourceClaim_To_v1beta2_ResourceClaim(in *resource.ResourceClaim, out *resourcev1beta2.ResourceClaim, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_ResourceClaim_To_v1beta2_ResourceClaim is an autogenerated conversion function.
func Convert_resource_ResourceClaim_To_v1beta2_ResourceClaim(in *resource.ResourceClaim, out *resourcev1beta2.ResourceClaim, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaim_To_v1beta2_ResourceClaim(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimConsumerReference_To_resource_ResourceClaimConsumerReference(in *resourcev1beta2.ResourceClaimConsumerReference, out *resource.ResourceClaimConsumerReference, s conversion.Scope) error {
	out.APIGroup = in.APIGroup
	out.Resource = in.Resource
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_v1beta2_ResourceClaimConsumerReference_To_resource_ResourceClaimConsumerReference is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimConsumerReference_To_resource_ResourceClaimConsumerReference(in *resourcev1beta2.ResourceClaimConsumerReference, out *resource.ResourceClaimConsumerReference, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimConsumerReference_To_resource_ResourceClaimConsumerReference(in, out, s)
}

func autoConvert_resource_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in *resource.ResourceClaimConsumerReference, out *resourcev1beta2.ResourceClaimConsumerReference, s conversion.Scope) error {
	out.APIGroup = in.APIGroup
	out.Resource = in.Resource
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_resource_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference is an autogenerated conversion function.
func Convert_resource_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in *resource.ResourceClaimConsumerReference, out *resourcev1beta2.ResourceClaimConsumerReference, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimList_To_resource_ResourceClaimList(in *resourcev1beta2.ResourceClaimList, out *resource.ResourceClaimList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resource.ResourceClaim)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_ResourceClaimList_To_resource_ResourceClaimList is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimList_To_resource_ResourceClaimList(in *resourcev1beta2.ResourceClaimList, out *resource.ResourceClaimList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimList_To_resource_ResourceClaimList(in, out, s)
}

func autoConvert_resource_ResourceClaimList_To_v1beta2_ResourceClaimList(in *resource.ResourceClaimList, out *resourcev1beta2.ResourceClaimList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resourcev1beta2.ResourceClaim)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_resource_ResourceClaimList_To_v1beta2_ResourceClaimList is an autogenerated conversion function.
func Convert_resource_ResourceClaimList_To_v1beta2_ResourceClaimList(in *resource.ResourceClaimList, out *resourcev1beta2.ResourceClaimList, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimList_To_v1beta2_ResourceClaimList(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(in *resourcev1beta2.ResourceClaimSpec, out *resource.ResourceClaimSpec, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceClaim_To_resource_DeviceClaim(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(in *resourcev1beta2.ResourceClaimSpec, out *resource.ResourceClaimSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(in, out, s)
}

func autoConvert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in *resource.ResourceClaimSpec, out *resourcev1beta2.ResourceClaimSpec, s conversion.Scope) error {
	if err := Convert_resource_DeviceClaim_To_v1beta2_DeviceClaim(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec is an autogenerated conversion function.
func Convert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in *resource.ResourceClaimSpec, out *resourcev1beta2.ResourceClaimSpec, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus(in *resourcev1beta2.ResourceClaimStatus, out *resource.ResourceClaimStatus, s conversion.Scope) error {
	out.Allocation = (*resource.AllocationResult)(unsafe.Pointer(in.Allocation))
	out.ReservedFor = *(*[]resource.ResourceClaimConsumerReference)(unsafe.Pointer(&in.ReservedFor))
	out.Devices = *(*[]resource.AllocatedDeviceStatus)(unsafe.Pointer(&in.Devices))
	return nil
}

// Convert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus(in *resourcev1beta2.ResourceClaimStatus, out *resource.ResourceClaimStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimStatus_To_resource_ResourceClaimStatus(in, out, s)
}

func autoConvert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in *resource.ResourceClaimStatus, out *resourcev1beta2.ResourceClaimStatus, s conversion.Scope) error {
	out.Allocation = (*resourcev1beta2.AllocationResult)(unsafe.Pointer(in.Allocation))
	out.ReservedFor = *(*[]resourcev1beta2.ResourceClaimConsumerReference)(unsafe.Pointer(&in.ReservedFor))
	out.Devices = *(*[]resourcev1beta2.AllocatedDeviceStatus)(unsafe.Pointer(&in.Devices))
	return nil
}

// Convert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus is an autogenerated conversion function.
func Convert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in *resource.ResourceClaimStatus, out *resourcev1beta2.ResourceClaimStatus, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplate_To_resource_ResourceClaimTemplate(in *resourcev1beta2.ResourceClaimTemplate, out *resource.ResourceClaimTemplate, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimTemplate_To_resource_ResourceClaimTemplate is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplate_To_resource_ResourceClaimTemplate(in *resourcev1beta2.ResourceClaimTemplate, out *resource.ResourceClaimTemplate, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplate_To_resource_ResourceClaimTemplate(in, out, s)
}

func autoConvert_resource_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in *resource.ResourceClaimTemplate, out *resourcev1beta2.ResourceClaimTemplate, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate is an autogenerated conversion function.
func Convert_resource_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in *resource.ResourceClaimTemplate, out *resourcev1beta2.ResourceClaimTemplate, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplateList_To_resource_ResourceClaimTemplateList(in *resourcev1beta2.ResourceClaimTemplateList, out *resource.ResourceClaimTemplateList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resource.ResourceClaimTemplate)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_ResourceClaimTemplateList_To_resource_ResourceClaimTemplateList is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplateList_To_resource_ResourceClaimTemplateList(in *resourcev1beta2.ResourceClaimTemplateList, out *resource.ResourceClaimTemplateList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplateList_To_resource_ResourceClaimTemplateList(in, out, s)
}

func autoConvert_resource_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in *resource.ResourceClaimTemplateList, out *resourcev1beta2.ResourceClaimTemplateList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resourcev1beta2.ResourceClaimTemplate)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_resource_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList is an autogenerated conversion function.
func Convert_resource_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in *resource.ResourceClaimTemplateList, out *resourcev1beta2.ResourceClaimTemplateList, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec(in *resourcev1beta2.ResourceClaimTemplateSpec, out *resource.ResourceClaimTemplateSpec, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimSpec_To_resource_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec(in *resourcev1beta2.ResourceClaimTemplateSpec, out *resource.ResourceClaimTemplateSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplateSpec_To_resource_ResourceClaimTemplateSpec(in, out, s)
}

func autoConvert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in *resource.ResourceClaimTemplateSpec, out *resourcev1beta2.ResourceClaimTemplateSpec, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_resource_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec is an autogenerated conversion function.
func Convert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in *resource.ResourceClaimTemplateSpec, out *resourcev1beta2.ResourceClaimTemplateSpec, s conversion.Scope) error {
	return autoConvert_resource_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in, out, s)
}

func autoConvert_v1beta2_ResourcePool_To_resource_ResourcePool(in *resourcev1beta2.ResourcePool, out *resource.ResourcePool, s conversion.Scope) error {
	out.Name = in.Name
	out.Generation = in.Generation
	out.ResourceSliceCount = in.ResourceSliceCount
	return nil
}

// Convert_v1beta2_ResourcePool_To_resource_ResourcePool is an autogenerated conversion function.
func Convert_v1beta2_ResourcePool_To_resource_ResourcePool(in *resourcev1beta2.ResourcePool, out *resource.ResourcePool, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourcePool_To_resource_ResourcePool(in, out, s)
}

func autoConvert_resource_ResourcePool_To_v1beta2_ResourcePool(in *resource.ResourcePool, out *resourcev1beta2.ResourcePool, s conversion.Scope) error {
	out.Name = in.Name
	out.Generation = in.Generation
	out.ResourceSliceCount = in.ResourceSliceCount
	return nil
}

// Convert_resource_ResourcePool_To_v1beta2_ResourcePool is an autogenerated conversion function.
func Convert_resource_ResourcePool_To_v1beta2_ResourcePool(in *resource.ResourcePool, out *resourcev1beta2.ResourcePool, s conversion.Scope) error {
	return autoConvert_resource_ResourcePool_To_v1beta2_ResourcePool(in, out, s)
}

func autoConvert_v1beta2_ResourceSlice_To_resource_ResourceSlice(in *resourcev1beta2.ResourceSlice, out *resource.ResourceSlice, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceSlice_To_resource_ResourceSlice is an autogenerated conversion function.
func Convert_v1beta2_ResourceSlice_To_resource_ResourceSlice(in *resourcev1beta2.ResourceSlice, out *resource.ResourceSlice, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceSlice_To_resource_ResourceSlice(in, out, s)
}

func autoConvert_resource_ResourceSlice_To_v1beta2_ResourceSlice(in *resource.ResourceSlice, out *resourcev1beta2.ResourceSlice, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_resource_ResourceSlice_To_v1beta2_ResourceSlice is an autogenerated conversion function.
func Convert_resource_ResourceSlice_To_v1beta2_ResourceSlice(in *resource.ResourceSlice, out *resourcev1beta2.ResourceSlice, s conversion.Scope) error {
	return autoConvert_resource_ResourceSlice_To_v1beta2_ResourceSlice(in, out, s)
}

func autoConvert_v1beta2_ResourceSliceList_To_resource_ResourceSliceList(in *resourcev1beta2.ResourceSliceList, out *resource.ResourceSliceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resource.ResourceSlice)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_ResourceSliceList_To_resource_ResourceSliceList is an autogenerated conversion function.
func Convert_v1beta2_ResourceSliceList_To_resource_ResourceSliceList(in *resourcev1beta2.ResourceSliceList, out *resource.ResourceSliceList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceSliceList_To_resource_ResourceSliceList(in, out, s)
}

func autoConvert_resource_ResourceSliceList_To_v1beta2_ResourceSliceList(in *resource.ResourceSliceList, out *resourcev1beta2.ResourceSliceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resourcev1beta2.ResourceSlice)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_resource_ResourceSliceList_To_v1beta2_ResourceSliceList is an autogenerated conversion function.
func Convert_resource_ResourceSliceList_To_v1beta2_ResourceSliceList(in *resource.ResourceSliceList, out *resourcev1beta2.ResourceSliceList, s conversion.Scope) error {
	return autoConvert_resource_ResourceSliceList_To_v1beta2_ResourceSliceList(in, out, s)
}

func autoConvert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec(in *resourcev1beta2.ResourceSliceSpec, out *resource.ResourceSliceSpec, s conversion.Scope) error {
	out.Driver = in.Driver
	if err := Convert_v1beta2_ResourcePool_To_resource_ResourcePool(&in.Pool, &out.Pool, s); err != nil {
		return err
	}
	out.NodeName = (*string)(unsafe.Pointer(in.NodeName))
	out.NodeSelector = (*core.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	out.AllNodes = (*bool)(unsafe.Pointer(in.AllNodes))
	out.Devices = *(*[]resource.Device)(unsafe.Pointer(&in.Devices))
	out.PerDeviceNodeSelection = (*bool)(unsafe.Pointer(in.PerDeviceNodeSelection))
	out.SharedCounters = *(*[]resource.CounterSet)(unsafe.Pointer(&in.SharedCounters))
	return nil
}

// Convert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec is an autogenerated conversion function.
func Convert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec(in *resourcev1beta2.ResourceSliceSpec, out *resource.ResourceSliceSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceSliceSpec_To_resource_ResourceSliceSpec(in, out, s)
}

func autoConvert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(in *resource.ResourceSliceSpec, out *resourcev1beta2.ResourceSliceSpec, s conversion.Scope) error {
	out.Driver = in.Driver
	if err := Convert_resource_ResourcePool_To_v1beta2_ResourcePool(&in.Pool, &out.Pool, s); err != nil {
		return err
	}
	out.NodeName = (*string)(unsafe.Pointer(in.NodeName))
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	out.AllNodes = (*bool)(unsafe.Pointer(in.AllNodes))
	out.Devices = *(*[]resourcev1beta2.Device)(unsafe.Pointer(&in.Devices))
	out.PerDeviceNodeSelection = (*bool)(unsafe.Pointer(in.PerDeviceNodeSelection))
	out.SharedCounters = *(*[]resourcev1beta2.CounterSet)(unsafe.Pointer(&in.SharedCounters))
	return nil
}

// Convert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec is an autogenerated conversion function.
func Convert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(in *resource.ResourceSliceSpec, out *resourcev1beta2.ResourceSliceSpec, s conversion.Scope) error {
	return autoConvert_resource_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(in, out, s)
}
